<?php

/**
 * Klasse General
 * Zeigt algemeine Einstellungen von der isgw.conf Datei
 */
class Miscellaneous {
    /*
     * Funktion display erzeugt den Inhalt von der HTML-Seite
     */

    function display() {

        $m = $_GET['m'];
        $name="MISCELLANEOUS_TITLE_DIS";
        include('./includes/header.php');
        $misc_table = $this->dynamic_table();
        // build page content

        $ret .= "
					<form class='extensions_form' name='miscellaneous' action='' method='POST'>
					<input type=hidden name=m value='" . $m . "'>
					<input type=hidden name=a value='save'>
					<br>
					" . $misc_table;

        //Rückgabe: Inhalt der HTML-Seite
        return $ret;
    }

    //SIP license reload
    function reload_sip_license(){
        require_once ('./includes/isgwtelnet.php');
        $isgw = new isgwtelnet();
        $isgw->isgw_login();
        $isgw->isgw_siplicenserefresh();
    }

    /*
     * Funktion dynamic_table
     */

    function dynamic_table() {
        $table = "";
        //Wenn man Änderugen von der Daten macht werden die in der Tabelle der Datenbank
        //aktualisiert
        require_once("./includes/lang.php");
        require_once('/usr/fallback/beroConf.php');
        $bc = new beroConf('root');
        $ba = new beroAri();

        if (isset($_GET['reload'])){
            $this->reload_sip_license();
        }
        //Upload SIP License
        if ($_FILES["uploadfile"]["name"] != "") {
            $file_name = $_FILES["uploadfile"]["name"];
            $tmp_file = $_FILES["uploadfile"]["tmp_name"];
            if ($file_name != "isgw_".SERIAL.".license") { //40 kB
                $table.="<div class='center'><font color='red'>" . MISCELLANEOUS_INVALID_FILENAME_DIS . "</font></div>";
            }elseif ($_FILES["uploadfile"]["size"] > 40000) { //40 kB
                $table.="<div class='center'><font color='red'>" . SIP_GENERAL_FILE_SIZE_DIS . "</font></div>";
            } else {
                    @unlink("/usr/conf/".$file_name);
                    exec("/bin/cp " . $tmp_file . " /usr/conf/".$file_name);
                    $this->reload_sip_license();
                    $table.="<div class='center'><font color='red'>" . SIP_GENERAL_UPLOAD_SUCCESS_DIS . "</font></div>";

            }
        }

        if ($_POST['action'] == 'save') {
            $option = 1;
            if (isset($_POST['experimental_options'])) {
                if ($_POST['experimental_options'] != $ba->get("experimental_options"))
                    $option = 2;
                $ba->set("experimental_options", sqlite_escape_string($_POST['experimental_options']));
            }

            $table.=Helper::activate($option, true, $_GET['m'], ACTIVATE);
        }

        $table .= "<table class='contenttoc' id='table'>
					<tr>
					<th colspan='2'>" . MISCELLANEOUS_TABLE_HEADER_DIS . "</th>
					</tr>
					<tr>
					<td><b>" . MISCELLANEOUS_EXPERIMENTAL_OPTIONS_DIS . ":</b></td>
					<td>
					<input type='text' id='experimental_options' name='experimental_options' value='" . $ba->get("experimental_options") . "'>
					</td>
					</tr>
					<tr>
					<td colspan='2'><input type='hidden' name='action' value='save'>
					<input name='submit' type='submit' value='".BUTTON_SAVE."' >
					</td>
					</tr>
					</table>
					<br>
					</form>
					<script type='text/javascript'>
					function show_tr_adminPass() {
						if ($('#userapp-enabled').is(':checked'))
							$('#admin-pass').css('display','');
						else
							$('#admin-pass').css('display','none');
					}
					$('#userapp-enabled').change( function(){ show_tr_adminPass(); });
					$(document).ready(function(){ show_tr_adminPass(); });
					</script>";

        $table.="<form class='extensions_form' ENCTYPE=\"multipart/form-data\" action='' method='POST'>
					<input type=hidden name=m value=" . $_GET['m'] . ">
					<table class='contenttoc'>
					<tr>
					<th colspan='2'>" . MISCELLANEOUS_SIP_LICENSE_TABLE_HEADER_DIS . "</th>
					</tr>
					<tr>
					<td><b>" . MISCELLANEOUS_UPLOAD_SIP_LICENSE_DIS . ":</b></td>
					<td nowrap><input type='file' size='28' name='uploadfile'></td>
					</tr>";

        if (file_exists("/usr/conf/isgw_".SERIAL.".license")) {
            //SIP license
		require_once ('./includes/isgwtelnet.php');
		$isgw = new isgwtelnet();
		$isgw->isgw_login();
		$sip_license_state=$isgw->isgw_siplicensestate();
		$sip_license_count=$isgw->isgw_siplicensecount();
                switch (trim($sip_license_state)) {
                    case "LICENSE_NONE":
                            $state=LICENSE_NONE;
                        break;
                    case "LICENSE_INVALID":
                            $state=LICENSE_INVALID;
                        break;
                    case "LICENSE_VALID":
                            $state=LICENSE_VALID;
                        break;

                    default:
                        break;
                }

            $table .= "<tr>
					<td><b>" . MISCELLANEOUS_SIP_LICENSE_STATE_DIS . ":</b></td>
					<td>" . $state . "</td>
                                            <tr>
					<td><b>" . MISCELLANEOUS_SIP_LICENSE_COUNT_DIS . ":</b></td>
                                            <td>" . $sip_license_count . "</td>
                                            <tr>
                                        <td><b>" . MISCELLANEOUS_SIP_LICENSE_DEL_DIS . ":</b></td>
					<td><input type='button' value='" . BUTTON_DELETE . "' onclick=\"javascript:if (confirm('" . MISCELLANEOUS_DELETE_LICENSE_MESS_DIS . "?')==true) window.location.href='misc/deletefile.php?m=".$_GET['m']."&option=sip_license';\"></td>
					</tr>";
        }
        $table .="<tr>
					<td colspan='2'><input name='save_lic' type='submit' value='" . BUTTON_SAVE . "'>
					</td>
					</tr>";
        $table .= "</table>
					</form>";
        //Rückgabe: Erzeugte Tabelle mit den änderbaren Feldern von den Einstellungen von isgw.conf
        return $table;
    }

}

?>
