//Das Feld für Kommentare wird auf 100 Zeichen begrenzt


function resize(){
	if(window.sizeToContent) window.sizeToContent();
}
function closeW(){
	this.window.close();
}

//Funktion für die Bewegung von Items von einem Listbox in den Anderen.
function move(Orig, Dest){
	var varFromBox = document.getElementById(Orig);
	var varToBox = document.getElementById(Dest);
	if ((varFromBox != null) && (varToBox != null))
	{
		if(varFromBox.length < 1)
		{
			alert('There are no items in the source ListBox');
			return false;
		}
		if(varFromBox.options.selectedIndex == -1) // when no Item is selected the index will be -1

		{
			alert('Please select an Item to move');
			return false;
		}
		while ( varFromBox.options.selectedIndex >= 0 )
		{
			var newOption = new Option(); // Create a new instance of ListItem

			newOption.text = varFromBox.options[varFromBox.options.selectedIndex].text;
			newOption.value = varFromBox.options[varFromBox.options.selectedIndex].value;
			varToBox.options[varToBox.length] = newOption; //Append the item in Target Listbox

			varFromBox.remove(varFromBox.options.selectedIndex); //Remove the item from Source Listbox

		}
	}
	return false;
}

function selectall(){
	selectBox = document.getElementById('sel');
	for (var i = 0; i < selectBox.options.length; i++) {
		selectBox.options[i].selected = true;
	}
}

function up() {
	obj=document.getElementById('sel');
	for (var i = 0; i < obj.options.length; i++)
		if (obj.options[ i ].selected){
			if (i>0) change(obj,i,i-1);
		}

}

function down() {
	obj=document.getElementById('sel');
	for (var i = obj.options.length-1; i >= 0; i--){
		if (obj.options[ i ].selected){
			if ( i<obj.length-1) change(obj,i,i+1);
		}
	}
}

function change(obj,num1,num2) {
	proVal=obj.options[num1].value;
	proTex=obj.options[num1].text;
	obj.options[num1].value=obj.options[num2].value;
	obj.options[num1].text=obj.options[num2].text;
	obj.options[num2].value=proVal;
	obj.options[num2].text=proTex;
	obj.options[num2].selected=true;
	obj.options[num1].selected=false;
}

function showdef_(conf,config,from,to){

	var c=config.split(",");
	for (i=0;i<c.length;i++){
		var v=c[i].split("=");
		if (v[0]=='codecs'){
			document.getElementById('sel').disabled=false;
			document.getElementById('sel1').disabled=false;
			document.getElementById('upB').disabled=false;
			document.getElementById('downB').disabled=false;
			document.getElementById('addB').disabled=false;
			document.getElementById('removeB').disabled=false;
		}else if (v[0]=='from_pstn_src_setting'){
			if (from=='analog' || to=='analog') document.getElementById('from_pstn_src_setting_analog').disabled=false;
			if (from=='isdn' || to=='isdn') document.getElementById('from_pstn_src_setting_isdn').disabled=false;
			var check_def=document.getElementById("def_from_pstn_src_setting_analog");
			if (check_def!=null && (from=='analog' || to=='analog')) check_def.checked=false;
			var check_def=document.getElementById("def_from_pstn_src_setting_isdn");
			if (check_def!=null && (from=='isdn' || to=='isdn')) check_def.checked=false;
		}else{
			var field=document.getElementById(v[0]);
			if (field!=null) field.disabled=false;
		}
		var check_def=document.getElementById("def_"+v[0]);
		if (check_def!=null) check_def.checked=false;
	}
}

function hidec(){
	var config_isdn=document.getElementById('config_isdn');
	var config_sip=document.getElementById('config_sip');
	var config_analog=document.getElementById('config_analog');
	var config_additional=document.getElementById('config_additional');
	var buttons=document.getElementById('buttons');
	config_sip.style.display="none";
	config_additional.style.display="none";
	config_isdn.style.display="none";
	config_analog.style.display="none";
	buttons.style.display="none";
}

//Config String tabelle anzeigen oder ausblenden (ISDN)
function show_config_isdn(){
	var config_isdn=document.getElementById('config_isdn');
	var config_sip=document.getElementById('config_sip');
	var config_analog=document.getElementById('config_analog');
	var config_additional=document.getElementById('config_additional');
	var buttons=document.getElementById('buttons');
	if (config_isdn.style.display=="none"){
		config_isdn.style.display="";
		buttons.style.display="";
		config_sip.style.display="none";
		config_analog.style.display="none";
		config_additional.style.display="none";
	}else{
		config_isdn.style.display="none";
		buttons.style.display="none";
	}
}

//Config String tabelle anzeigen oder ausblenden (Additional)
function show_config_addit(){
	var config_isdn=document.getElementById('config_isdn');
	var config_analog=document.getElementById('config_analog');
	var config_additional=document.getElementById('config_additional');
	var config_sip=document.getElementById('config_sip');
	var buttons=document.getElementById('buttons');
	if (config_additional.style.display=="none"){
		config_additional.style.display="";
		buttons.style.display="";
		config_sip.style.display="none";
		config_isdn.style.display="none";
		config_analog.style.display="none";
		$("#addit_options").focus();
	}else{
		config_additional.style.display="none";
		buttons.style.display="none";
	}
}

//Config String tabelle anzeigen oder ausblenden (SIP)
function show_config_sip(){
	var config_sip=document.getElementById('config_sip');
	var config_isdn=document.getElementById('config_isdn');
	var config_analog=document.getElementById('config_analog');
	var config_additional=document.getElementById('config_additional');
	var buttons=document.getElementById('buttons');
	if (config_sip.style.display=="none"){
		config_sip.style.display="";
		buttons.style.display="";
		config_isdn.style.display="none";
		config_analog.style.display="none";
		config_additional.style.display="none";
	}else{
		config_sip.style.display="none";
		buttons.style.display="none";
	}
}

//Config String tabelle anzeigen oder ausblenden (ANALOG)
function show_config_analog(){
	var config_sip=document.getElementById('config_sip');
	var config_isdn=document.getElementById('config_isdn');
	var config_analog=document.getElementById('config_analog');
	var config_additional=document.getElementById('config_additional');
	var buttons=document.getElementById('buttons');
	if (config_analog.style.display=="none"){
		config_analog.style.display="";
		buttons.style.display="";
		config_sip.style.display="none";
		config_isdn.style.display="none";
		config_additional.style.display="none";
	}else{
		config_analog.style.display="none";
		buttons.style.display="none";
	}
}


function disable(){
	var ec= document.getElementById("ec");
	ec.disabled=true;
	var ectl= document.getElementById("ectl");
	ectl.disabled=true;
	var ie_on_sip= document.getElementById("ie_on_sip");
	ie_on_sip.disabled=true;
	var wait_for_cancel= document.getElementById("wait_for_cancel");
	wait_for_cancel.disabled=true;
	var dton = document.getElementById("dton");
	dton.disabled=true;
	var oton= document.getElementById("oton");
	oton.disabled=true;
	var screen= document.getElementById("screen");
	screen.disabled=true;
	var pres= document.getElementById("pres");
	pres.disabled=true;
	var t38= document.getElementById("t38");
	t38.disabled=true;
	var dtmfmode= document.getElementById("dtmfmode");
	dtmfmode.disabled=true;
	var s2i_cpt= document.getElementById("s2i_cpt");
	s2i_cpt.disabled=true;
	var i2s_cpt= document.getElementById("i2s_cpt");
	i2s_cpt.disabled=true;
	var codecs= document.getElementById("sel");
	codecs.disabled=true;
	var codecs1= document.getElementById("sel1");
	codecs1.disabled=true;
	var upB= document.getElementById("upB");
	upB.disabled=true;
	var downB= document.getElementById("downB");
	downB.disabled=true;
	var addB= document.getElementById("addB");
	addB.disabled=true;
	var removeB= document.getElementById("removeB");
	removeB.disabled=true;
	var bearer_cap= document.getElementById("bearer_cap");
	bearer_cap.disabled=true;
	var cd= document.getElementById("cd");
	cd.disabled=true;
	var isdn_oad_setting= document.getElementById("isdn_oad_setting");
	isdn_oad_setting.disabled=true;
	var isdn_oad2_setting= document.getElementById("isdn_oad2_setting");
	isdn_oad2_setting.disabled=true;
	var isdn_qsigname_setting= document.getElementById("isdn_qsigname_setting");
	isdn_qsigname_setting.disabled=true;
	var isdn_redirected_nr_setting= document.getElementById("isdn_redirected_nr_setting");
	isdn_redirected_nr_setting.disabled=true;
	var from_pstn_src_setting_analog= document.getElementById("from_pstn_src_setting_analog");
	from_pstn_src_setting_analog.disabled=true;
	var from_pstn_src_setting_isdn= document.getElementById("from_pstn_src_setting_isdn");
	from_pstn_src_setting_isdn.disabled=true;
	var sip_to_user_setting= document.getElementById("sip_to_user_setting");
	sip_to_user_setting.disabled=true;
	var sip_from_user_setting= document.getElementById("sip_from_user_setting");
	sip_from_user_setting.disabled=true;
	var sip_from_display_setting= document.getElementById("sip_from_display_setting");
	sip_from_display_setting.disabled=true;
	var from_sip_src_setting= document.getElementById("from_sip_src_setting");
	from_sip_src_setting.disabled=true;
	var analog_oad_setting= document.getElementById("analog_oad_setting");
	analog_oad_setting.disabled=true;
	var analog_display_setting= document.getElementById("analog_display_setting");
	analog_display_setting.disabled=true;
	var sip_national_code= document.getElementById("sip_national_code");
	sip_national_code.disabled=true;
	var sip_international_code= document.getElementById("sip_international_code");
	sip_international_code.disabled=true;
	var isdn2sip_destination_numformat= document.getElementById("isdn2sip_destination_numformat");
	isdn2sip_destination_numformat.disabled=true;
	var dialplan_international_prefix= document.getElementById("dialplan_international_prefix");
	dialplan_international_prefix.disabled=true;
        $("#sip2dialplan_dad_prefix_setting").prop("disabled",true);
        $("#sip2dialplan_oad_prefix_setting").prop("disabled",true);
        $("#dialplan2sip_oad_prefix_setting").prop("disabled",true);
        $("#srtp_mode").prop("disabled",true);
        $("#srtp_crypto_suites").prop("disabled",true);
}

function hide_elements(from_to){
	hidec();
	var t38_tr=document.getElementById("t38_tr");
	var dtmf_tr=document.getElementById("dtmf_tr");
	var s2i_cpt_tr=document.getElementById("s2i_cpt_tr");
	var i2s_cpt_tr=document.getElementById("i2s_cpt_tr");
	var ie_on_sip_tr=document.getElementById("ie_on_sip_tr");
	var wait_for_cancel_tr=document.getElementById("wait_for_cancel_tr");
	var codecs_tr=document.getElementById("codecs_tr");
	var from_sip_src_setting_tr=document.getElementById("from_sip_src_setting_tr");
	var sip_from_user_setting_tr=document.getElementById("sip_from_user_setting_tr");
	var sip_to_user_setting_tr=document.getElementById("sip_to_user_setting_tr");
	var sip_from_display_setting_tr=document.getElementById("sip_from_display_setting_tr");
	var called_party_number_tr=document.getElementById("called_party_number_tr");
	var caller_id_mapping_tr=document.getElementById("caller_id_mapping_tr");
	var provider_int_number_format_tr=document.getElementById("provider_int_number_format_tr");
	var sip_national_code_tr=document.getElementById("sip_national_code_tr");
	var sip_international_code_tr=document.getElementById("sip_international_code_tr");
	var isdn2sip_destination_numformat_tr=document.getElementById("isdn2sip_destination_numformat_tr");
	var isdn2sip_tr=document.getElementById("isdn2sip_tr");
	var sip2isdn_tr=document.getElementById("sip2isdn_tr");
	var dialplan_international_prefix_tr=document.getElementById("dialplan_international_prefix_tr");
	var sip2dialplan_dad_prefix_setting_tr=document.getElementById("sip2dialplan_dad_prefix_setting_tr");
	var sip2dialplan_oad_prefix_setting_tr=document.getElementById("sip2dialplan_oad_prefix_setting_tr");
	var dialplan2sip_oad_prefix_setting_tr=document.getElementById("dialplan2sip_oad_prefix_setting_tr");
	var srtp_mode_tr=document.getElementById("srtp_mode_tr");
	var srtp_crypto_suites_tr=document.getElementById("srtp_crypto_suites_tr");
	 if ( from_to=="isdn-isdn" ){
			t38_tr.style.display="none";
			dtmf_tr.style.display="none";
			s2i_cpt_tr.style.display="";
			i2s_cpt_tr.style.display="";
			codecs_tr.style.display="none";
			wait_for_cancel_tr.style.display="none";
			from_sip_src_setting_tr.style.display="none";
			sip_to_user_setting_tr.style.display="none";
			sip_from_user_setting_tr.style.display="none";
			sip_from_display_setting_tr.style.display="none";
			called_party_number_tr.style.display="none";
			caller_id_mapping_tr.style.display="none";
			provider_int_number_format_tr.style.display="none";
			sip_national_code_tr.style.display="none";
			sip_international_code_tr.style.display="none";
			isdn2sip_destination_numformat_tr.style.display="none";
			isdn2sip_tr.style.display="none";
			sip2isdn_tr.style.display="none";
			dialplan_international_prefix_tr.style.display="none";
			sip2dialplan_dad_prefix_setting_tr.style.display="none";
			sip2dialplan_oad_prefix_setting_tr.style.display="none";
			dialplan2sip_oad_prefix_setting_tr.style.display="none";
			srtp_mode_tr.style.display="none";
			srtp_crypto_suites_tr.style.display="none";
			ie_on_sip_tr.style.display="";
		}else{
			t38_tr.style.display="";
			dtmf_tr.style.display="";
			i2s_cpt_tr.style.display="";
			codecs_tr.style.display="";
			ie_on_sip_tr.style.display="";
			from_sip_src_setting_tr.style.display="";
			sip_to_user_setting_tr.style.display="";
			sip_from_user_setting_tr.style.display="";
			sip_from_display_setting_tr.style.display="";
			called_party_number_tr.style.display="";
			caller_id_mapping_tr.style.display="";
                        provider_int_number_format_tr.style.display="";
			sip_national_code_tr.style.display="";
			sip_international_code_tr.style.display="";
			isdn2sip_destination_numformat_tr.style.display="";
			isdn2sip_tr.style.display="";
			sip2isdn_tr.style.display="";
			dialplan_international_prefix_tr.style.display="";
			sip2dialplan_dad_prefix_setting_tr.style.display="";
			sip2dialplan_oad_prefix_setting_tr.style.display="";
			dialplan2sip_oad_prefix_setting_tr.style.display="";
			srtp_mode_tr.style.display="";
			srtp_crypto_suites_tr.style.display="";
		}
                srtp();
}


function is_submit(form)
{
	var elem = document.getElementsByTagName("input");
	for (i=0;i<elem.length;i++){
		if (elem[i].type=="text"){
			elem[i].value= elem[i].value.replace(/\"/g,"\"");
			elem[i].value= elem[i].value.replace(/\'/g,"\"");
		}
	}
	return true;
}

function srtp(){
    if ($("#srtp_mode").val()=="off"){
        $("#def_srtp_crypto_suites").prop("checked",true);
        $("#srtp_crypto_suites").prop("disabled",true);
        $("#srtp_crypto_suites_tr").hide();
    }else{ 
        $("#srtp_crypto_suites_tr").show();
    }
}
