<?php
/**
 * @file
 * popup window for isdn and anolog groups
 */
chdir("../..");

include "./includes/variables.php";
include "./misc/database.php";
include("./misc/config_parameter.php");
$ba = new beroAri();
require_once ('./includes/lang.php');
require_once('/usr/local/www/berogui/includes/session.php');


?>


<script type="text/javascript">
    $("#acll").validate({
                    
        rules: {
                        
            address: { 
                checkHostname : true, 
                required: true
            },
            netmask: {
                required:true,
                digits: true,
                range: [0,32],
                },
                manual_dest_port: {
                    required: {
                        depends: function (element) {
                            return $("#dest_port option:selected").val() == "manual";
                        }
                    },
                    digits: true,
                    range: [1, 65535],
                },
            }
        });

        $("#dest_port").change(function () {
            required();
        });

        function required() {
            if ($("#dest_port option:selected").val() == "manual") {
                addAsterisk("manual_dest_port");
            } else {
                deleteAsterisk("manual_dest_port");
            }
        }

        function hide_elements() {
            if ($('#dest_port').val() === "manual")
                $('#manual_dest_port').show();
            else
                $('#manual_dest_port').hide();
        }

</script>
<?php

function protocol($id){
    $allProtocol=array(""=>"All","udp"=>"UDP","tcp"=>"TCP");
    if ($id!="") $protocol=  getValue ($id, "protocol");
    $result="<select name='protocol'>";
    foreach ($allProtocol as $key=>$value){
        ($key===$protocol) ? $selected="selected='true'" : $selected="";
        $result.="<option value='$key' $selected>$value</option>";
    }
    $result.="</select>";
    return $result;
}
function dest_port($id){
    $port=array(-1=>"SIP",-2=>"SIP-TLS",80=>"HTTP",443=>"HTTPS",54322=>"Telnet",22=>"SSH",161=>"SNMP",162=>"SNMP-Trap",65001=>"bfdetect","all" => "All");
    if ($id!="") {
        $dest_port=  getValue ($id, "dest_port");
        if (!array_key_exists($dest_port, $port)){
            $manual="selected='true'";
            $manual_port=$dest_port;
        }
    }
    $result="<select name='dest_port' id='dest_port' onchange='hide_elements();'>";
    foreach ($port as $key=>$value){
        ($key==$dest_port) ? $selected="selected='true'" : $selected="";
        $result.="<option value='$key' $selected >$value</option>";
    }
    $result.="<option value='manual' $manual>Manual</option>";
    
    $result.="<input name='manual_dest_port' id='manual_dest_port' value='$manual_port'>";
    $result.="</select>";
    return $result;
}
function acl_rule($id){
    $address= getValue ($id, "address");
    $netmask= getValue ($id, "netmask");
    $result="<input type='text' name='address' value='$address' size='15' />&nbsp;/&nbsp;<input type='text' name='netmask' value='$netmask'size='2' />"; 
    return $result;
}
function getValue($id,$colname){
    $ba=new beroAri();
    $query=$ba->select("select $colname from acl where id='$id'");
    return sqlite_fetch_single($query);
}
require_once "./includes/isgwtelnet.php";
$id=sqlite_escape_string($_GET['id']);

echo ("<form class='extensions_form' name='acll' id='acll' action='modules/Acl/acl_submit.php' method='POST'>
                        <input type=hidden name='start' value='" . $page . "'>
			<table class='contenttoc'>
			<tr>
			<td><b>" . ACL_PROTOCOL_DIS . ":</b>&nbsp;</td>
			<td>".protocol($id)."</td>
			</tr>
			<tr>
			<td><b><label for='manual_dest_port'>" . ACL_DEST_PORT_DIS . "</label>:</b>&nbsp;</td>
			<td>".dest_port($id)."</td>
			</tr>
			<tr>
			<td><b><label for='address'>" . ACL_ACL_RULE_DIS . "</label>:</b>&nbsp;</td>
			<td style='white-space: nowrap'>".acl_rule($id)."</td>
			</tr>
			</table>
			<div class='center'><i>* ".REQUIRED_FIELDS."</i></div>");

echo ("<br/>
			<input type='hidden' name='id_upd' value='" . $id . "'>
			<div class='center'><input name='submit' type='submit' value='" . BUTTON_SAVE . "' onmouseover=\"Tip('" . ANALOG_SAVE . "');\" onmouseout='UnTip();'>
			 &nbsp;&nbsp;<input name='close' type='button' value='" . BUTTON_CLOSE . "' onclick='javascript:$(\"#dialog\").dialog(\"close\");' onmouseover=\"Tip('" . POPUPS_BUTTON_CLOSE . "');\" onmouseout='UnTip();'>
			</div></form>");


?>


